Index: LMDZ6/branches/Amaury_dev/libf/phylmd/phytrac_mod.F90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/phylmd/phytrac_mod.F90	(revision 5095)
+++ LMDZ6/branches/Amaury_dev/libf/phylmd/phytrac_mod.F90	(revision 5098)
@@ -778,35 +768,35 @@
     !======================================================================
 
-    DO it=1,nbtr
-       DO k=1,klev
-          DO i=1,klon
-             d_tr_th(i,k,it)=0.
-             tr_seri(i,k,it)=MAX(tr_seri(i,k,it),0.)
-! the next safeguard causes some problem for stratospheric aerosol tracers (particle number)
-! and there is little justification for it so it is commented out (4 December 2017) by OB
-! if reinstated please keep the ifndef CPP_StratAer
-!#ifndef CPP_StratAer
-!             tr_seri(i,k,it)=MIN(tr_seri(i,k,it),1.e10)
-!#endif
+    DO it = 1, nbtr
+      DO k = 1, klev
+        DO i = 1, klon
+          d_tr_th(i, k, it) = 0.
+          tr_seri(i, k, it) = MAX(tr_seri(i, k, it), 0.)
+          ! the next safeguard causes some problem for stratospheric aerosol tracers (particle number)
+          ! and there is little justification for it so it is commented out (4 December 2017) by OB
+          ! if reinstated please keep the ifndef CPP_StratAer
+          !#ifndef CPP_StratAer
+          !             tr_seri(i,k,it)=MIN(tr_seri(i,k,it),1.e10)
+          !#endif
+        ENDDO
+      ENDDO
+    ENDDO
+
+    IF (iflag_thermals>0.AND.iflag_the_trac>0) THEN
+
+      DO it = 1, nbtr
+
+        CALL thermcell_dq(klon, klev, 1, pdtphys, fm_therm, entr_therm, &
+                zmasse, tr_seri(1:klon, 1:klev, it), &
+                d_tr_th(1:klon, 1:klev, it), ztra_th, 0)
+
+        DO k = 1, klev
+          DO i = 1, klon
+            d_tr_th(i, k, it) = pdtphys * d_tr_th(i, k, it)
+            tr_seri(i, k, it) = MAX(tr_seri(i, k, it) + d_tr_th(i, k, it), 0.)
           ENDDO
-       ENDDO
-    ENDDO
-
-    IF (iflag_thermals>0.AND.iflag_the_trac>0) THEN
-
-       DO it=1, nbtr
-
-          CALL thermcell_dq(klon,klev,1,pdtphys,fm_therm,entr_therm, &
-               zmasse,tr_seri(1:klon,1:klev,it),        &
-               d_tr_th(1:klon,1:klev,it),ztra_th,0 )
-
-          DO k=1,klev
-             DO i=1,klon
-                d_tr_th(i,k,it)=pdtphys*d_tr_th(i,k,it)
-                tr_seri(i,k,it)=MAX(tr_seri(i,k,it)+d_tr_th(i,k,it),0.)
-             ENDDO
-          ENDDO
-
-       ENDDO ! it
+        ENDDO
+
+      ENDDO ! it
 
     ENDIF ! Thermiques
@@ -818,82 +808,82 @@
     IF (iflag_vdf_trac==1) THEN
 
-       !  Injection during BL mixing
-       !
-#ifdef CPP_StratAer
-       IF (type_trac=='coag') THEN
-
-         ! initialize dry deposition flux of sulfur
-         budg_dep_dry_ocs(:)=0.0
-         budg_dep_dry_so2(:)=0.0
-         budg_dep_dry_h2so4(:)=0.0
-         budg_dep_dry_part(:)=0.0
-
-         ! compute dry deposition velocity as function of surface type (numbers
-         ! from IPSL note 23, 2002)
-         v_dep_dry(:) =  pctsrf(:,is_ter) * 2.5e-3 &
-   + pctsrf(:,is_oce) * 0.5e-3 &
-   + pctsrf(:,is_lic) * 2.5e-3 &
-   + pctsrf(:,is_sic) * 2.5e-3
-
-         ! compute surface dry deposition flux
-         zrho(:,1)=pplay(:,1)/t_seri(:,1)/RD
-
-         DO it=1, nbtr
-          source(:,it) = - v_dep_dry(:) * tr_seri(:,1,it) * zrho(:,1)
-         ENDDO
-
-       ENDIF
-#endif
-
-       DO it=1, nbtr
+      !  Injection during BL mixing
+      !
+      IF (CPPKEY_STRATAER) THEN
+        IF (type_trac=='coag') THEN
+
+          ! initialize dry deposition flux of sulfur
+          budg_dep_dry_ocs(:) = 0.0
+          budg_dep_dry_so2(:) = 0.0
+          budg_dep_dry_h2so4(:) = 0.0
+          budg_dep_dry_part(:) = 0.0
+
+          ! compute dry deposition velocity as function of surface type (numbers
+          ! from IPSL note 23, 2002)
+          v_dep_dry(:) = pctsrf(:, is_ter) * 2.5e-3 &
+                  + pctsrf(:, is_oce) * 0.5e-3 &
+                  + pctsrf(:, is_lic) * 2.5e-3 &
+                  + pctsrf(:, is_sic) * 2.5e-3
+
+          ! compute surface dry deposition flux
+          zrho(:, 1) = pplay(:, 1) / t_seri(:, 1) / RD
+
+          DO it = 1, nbtr
+            source(:, it) = - v_dep_dry(:) * tr_seri(:, 1, it) * zrho(:, 1)
+          ENDDO
+
+        ENDIF
+      END IF
+
+      DO it = 1, nbtr
+        !
+        IF (pbl_flg(it) /= 0) THEN
           !
-          IF (pbl_flg(it) /= 0) THEN
-             !
-             CALL cltrac(pdtphys, coefh,t_seri,       &
-                  tr_seri(:,:,it), source(:,it),      &
-                  paprs, pplay, delp,                 &
-                  d_tr_cl(:,:,it),d_tr_dry(:,it),flux_tr_dry(:,it))
-             !
-             tr_seri(:,:,it)=tr_seri(:,:,it)+d_tr_cl(:,:,it)
-             !
-#ifdef CPP_StratAer
-             IF (type_trac=='coag') THEN
-               ! compute dry deposition flux of sulfur (sum over gases and particles)
-               IF (it==id_OCS_strat) THEN
-                 budg_dep_dry_ocs(:)=budg_dep_dry_ocs(:)-source(:,it)*(mSatom/mOCSmol)
-               ELSEIF (it==id_SO2_strat) THEN
-                 budg_dep_dry_so2(:)=budg_dep_dry_so2(:)-source(:,it)*(mSatom/mSO2mol)
-               ELSEIF (it==id_H2SO4_strat) THEN
-                 budg_dep_dry_h2so4(:)=budg_dep_dry_h2so4(:)-source(:,it)*(mSatom/mH2SO4mol)
-               ELSEIF (it.GT.nbtr_sulgas) THEN
-                 budg_dep_dry_part(:)=budg_dep_dry_part(:)-source(:,it)*(mSatom/mH2SO4mol)*dens_aer_dry &
-   *4./3.*RPI*(mdw(it-nbtr_sulgas)/2.)**3
-               ENDIF
-             ENDIF
-#endif
-             !
-          ENDIF
+          CALL cltrac(pdtphys, coefh, t_seri, &
+                  tr_seri(:, :, it), source(:, it), &
+                  paprs, pplay, delp, &
+                  d_tr_cl(:, :, it), d_tr_dry(:, it), flux_tr_dry(:, it))
           !
-       ENDDO
-       !
+          tr_seri(:, :, it) = tr_seri(:, :, it) + d_tr_cl(:, :, it)
+          !
+          IF (CPPKEY_STRATAER) THEN
+            IF (type_trac=='coag') THEN
+              ! compute dry deposition flux of sulfur (sum over gases and particles)
+              IF (it==id_OCS_strat) THEN
+                budg_dep_dry_ocs(:) = budg_dep_dry_ocs(:) - source(:, it) * (mSatom / mOCSmol)
+              ELSEIF (it==id_SO2_strat) THEN
+                budg_dep_dry_so2(:) = budg_dep_dry_so2(:) - source(:, it) * (mSatom / mSO2mol)
+              ELSEIF (it==id_H2SO4_strat) THEN
+                budg_dep_dry_h2so4(:) = budg_dep_dry_h2so4(:) - source(:, it) * (mSatom / mH2SO4mol)
+              ELSEIF (it>nbtr_sulgas) THEN
+                budg_dep_dry_part(:) = budg_dep_dry_part(:) - source(:, it) * (mSatom / mH2SO4mol) * dens_aer_dry &
+                        * 4. / 3. * RPI * (mdw(it - nbtr_sulgas) / 2.)**3
+              ENDIF
+            ENDIF
+          END IF
+          !
+        ENDIF
+        !
+      ENDDO
+      !
     ELSE IF (iflag_vdf_trac==0) THEN
-       !
-       !   Injection of source in the first model layer
-       !
-       DO it=1,nbtr
-          d_tr_cl(:,1,it)=source(:,it)*RG/delp(:,1)*pdtphys
-          tr_seri(:,1,it)=tr_seri(:,1,it)+d_tr_cl(:,1,it)
-       ENDDO
-       d_tr_cl(:,2:klev,1:nbtr)=0.
-       !
+      !
+      !   Injection of source in the first model layer
+      !
+      DO it = 1, nbtr
+        d_tr_cl(:, 1, it) = source(:, it) * RG / delp(:, 1) * pdtphys
+        tr_seri(:, 1, it) = tr_seri(:, 1, it) + d_tr_cl(:, 1, it)
+      ENDDO
+      d_tr_cl(:, 2:klev, 1:nbtr) = 0.
+      !
     ELSE IF (iflag_vdf_trac==-1) THEN
-       !
-       ! Nothing happens
-       d_tr_cl=0.
-       !
+      !
+      ! Nothing happens
+      d_tr_cl = 0.
+      !
     ELSE
-       !
-       CALL abort_physic('iflag_vdf_trac', 'cas non prevu',1)
-       !
+      !
+      CALL abort_physic('iflag_vdf_trac', 'cas non prevu', 1)
+      !
     ENDIF ! couche limite
 
@@ -905,191 +895,191 @@
     IF (lessivage) THEN
 
-       ql_incloud_ref = 10.e-4
-       ql_incloud_ref =  5.e-4
-
-
-       ! calcul du contenu en eau liquide au sein du nuage
-       ql_incl = ql_incloud_ref
-       ! choix du lessivage
-       !
-       IF (iflag_lscav == 3 .OR. iflag_lscav == 4) THEN
-          ! ********  Olivier Boucher version (3) possibly with modified ql_incl (4)
-          !
-          DO it = 1, nbtr
-
-             IF (aerosol(it)) THEN
-             !  incloud scavenging and removal by large scale rain ! orig : ql_incl was replaced by 0.5e-3 kg/kg
-             ! the value 0.5e-3 kg/kg is from Giorgi and Chameides (1986), JGR
-             ! Liu (2001) proposed to use 1.5e-3 kg/kg
-
-             CALL lsc_scav(pdtphys,it,iflag_lscav,aerosol,ql_incl,prfl,psfl,rneb,beta_fisrt,  &
-                           beta_v1,pplay,paprs,t_seri,tr_seri,d_tr_insc,d_tr_bcscav,d_tr_evapls,qPrls)
-
-             !large scale scavenging tendency
-             DO k = 1, klev
-                DO i = 1, klon
-                   d_tr_ls(i,k,it)=d_tr_insc(i,k,it)+d_tr_bcscav(i,k,it)+d_tr_evapls(i,k,it)
-                   tr_seri(i,k,it)=tr_seri(i,k,it)+d_tr_ls(i,k,it)
+      ql_incloud_ref = 10.e-4
+      ql_incloud_ref = 5.e-4
+
+
+      ! calcul du contenu en eau liquide au sein du nuage
+      ql_incl = ql_incloud_ref
+      ! choix du lessivage
+      !
+      IF (iflag_lscav == 3 .OR. iflag_lscav == 4) THEN
+        ! ********  Olivier Boucher version (3) possibly with modified ql_incl (4)
+        !
+        DO it = 1, nbtr
+
+          IF (aerosol(it)) THEN
+            !  incloud scavenging and removal by large scale rain ! orig : ql_incl was replaced by 0.5e-3 kg/kg
+            ! the value 0.5e-3 kg/kg is from Giorgi and Chameides (1986), JGR
+            ! Liu (2001) proposed to use 1.5e-3 kg/kg
+
+            CALL lsc_scav(pdtphys, it, iflag_lscav, aerosol, ql_incl, prfl, psfl, rneb, beta_fisrt, &
+                    beta_v1, pplay, paprs, t_seri, tr_seri, d_tr_insc, d_tr_bcscav, d_tr_evapls, qPrls)
+
+            !large scale scavenging tendency
+            DO k = 1, klev
+              DO i = 1, klon
+                d_tr_ls(i, k, it) = d_tr_insc(i, k, it) + d_tr_bcscav(i, k, it) + d_tr_evapls(i, k, it)
+                tr_seri(i, k, it) = tr_seri(i, k, it) + d_tr_ls(i, k, it)
+              ENDDO
+            ENDDO
+            CALL minmaxqfi(tr_seri(:, :, it), 0., 1.e33, 'lsc scav it = ' // TRIM(int2str(it)))
+          ENDIF
+
+        ENDDO  !tr
+
+        IF (CPPKEY_STRATAER) THEN
+          IF (type_trac=='coag') THEN
+            ! compute wet deposition flux of sulfur (sum over gases and
+            ! particles) and convert to kg(S)/m2/s
+            ! adding contribution of d_tr_ls to d_tr_cv (above)
+            DO i = 1, klon
+              DO k = 1, klev
+                DO it = 1, nbtr
+                  IF (it==id_OCS_strat) THEN
+                    budg_dep_wet_ocs(i) = budg_dep_wet_ocs(i) + d_tr_ls(i, k, it) * (mSatom / mOCSmol) &
+                            * (paprs(i, k) - paprs(i, k + 1)) / RG / pdtphys
+                  ELSEIF (it==id_SO2_strat) THEN
+                    budg_dep_wet_so2(i) = budg_dep_wet_so2(i) + d_tr_ls(i, k, it) * (mSatom / mSO2mol) &
+                            * (paprs(i, k) - paprs(i, k + 1)) / RG / pdtphys
+                  ELSEIF (it==id_H2SO4_strat) THEN
+                    budg_dep_wet_h2so4(i) = budg_dep_wet_h2so4(i) + d_tr_ls(i, k, it) * (mSatom / mH2SO4mol) &
+                            * (paprs(i, k) - paprs(i, k + 1)) / RG / pdtphys
+                  ELSEIF (it>nbtr_sulgas) THEN
+                    budg_dep_wet_part(i) = budg_dep_wet_part(i) + d_tr_ls(i, k, it) * (mSatom / mH2SO4mol)  &
+                            * dens_aer_dry * 4. / 3. * RPI * (mdw(it - nbtr_sulgas) / 2.)**3 &
+                            * (paprs(i, k) - paprs(i, k + 1)) / RG / pdtphys
+                  ENDIF
                 ENDDO
-             ENDDO
-             CALL minmaxqfi(tr_seri(:,:,it),0.,1.e33,'lsc scav it = '//TRIM(int2str(it)))
-             ENDIF
-
-          ENDDO  !tr
-
-#ifdef CPP_StratAer
-         IF (type_trac=='coag') THEN
-           ! compute wet deposition flux of sulfur (sum over gases and
-           ! particles) and convert to kg(S)/m2/s
-           ! adding contribution of d_tr_ls to d_tr_cv (above)
-           DO i = 1, klon
-           DO k = 1, klev
-           DO it = 1, nbtr
-             IF (it==id_OCS_strat) THEN
-               budg_dep_wet_ocs(i)=budg_dep_wet_ocs(i)+d_tr_ls(i,k,it)*(mSatom/mOCSmol) &
-   *(paprs(i,k)-paprs(i,k+1))/RG/pdtphys
-             ELSEIF (it==id_SO2_strat) THEN
-               budg_dep_wet_so2(i)=budg_dep_wet_so2(i)+d_tr_ls(i,k,it)*(mSatom/mSO2mol) &
-   *(paprs(i,k)-paprs(i,k+1))/RG/pdtphys
-             ELSEIF (it==id_H2SO4_strat) THEN
-               budg_dep_wet_h2so4(i)=budg_dep_wet_h2so4(i)+d_tr_ls(i,k,it)*(mSatom/mH2SO4mol) &
-   *(paprs(i,k)-paprs(i,k+1))/RG/pdtphys
-             ELSEIF (it.GT.nbtr_sulgas) THEN
-               budg_dep_wet_part(i)=budg_dep_wet_part(i)+d_tr_ls(i,k,it)*(mSatom/mH2SO4mol)  &
-   *dens_aer_dry*4./3.*RPI*(mdw(it-nbtr_sulgas)/2.)**3 &
-   *(paprs(i,k)-paprs(i,k+1))/RG/pdtphys
-             ENDIF
-           ENDDO
-           ENDDO
-           ENDDO
-         ENDIF
-#endif
-
-       ELSE IF (iflag_lscav == 2) THEN ! frac_impa, frac_nucl
-          ! *********   modified  old version
-
-          d_tr_lessi_nucl(:,:,:) = 0. 
-          d_tr_lessi_impa(:,:,:) = 0.
-          flestottr(:,:,:) = 0. 
-          ! Tendance des aerosols nuclees et impactes 
-          DO it = 1, nbtr
-             IF (aerosol(it)) THEN
-                his_dh(:)=0.
-                DO k = 1, klev
-                   DO i = 1, klon
-                      !PhH
-                      zrho(i,k)=pplay(i,k)/t_seri(i,k)/RD
-                      zdz(i,k)=(paprs(i,k)-paprs(i,k+1))/zrho(i,k)/RG
-                      !
-                   ENDDO
-                ENDDO
-
-                DO k=klev-1, 1, -1
-                   DO i=1, klon
-                      !             d_tr_ls(i,k,it)=tr_seri(i,k,it)*(frac_impa(i,k)*frac_nucl(i,k)-1.)
-                      dx=d_tr_ls(i,k,it)
-                      his_dh(i)=his_dh(i)-dx*zrho(i,k)*zdz(i,k)/pdtphys !  kg/m2/s
-                      evaplsc = prfl(i,k) - prfl(i,k+1) + psfl(i,k) - psfl(i,k+1)
-                      ! Evaporation Partielle -> Liberation Partielle 0.5*evap
-                      IF ( evaplsc <0..and.abs(prfl(i,k+1)+psfl(i,k+1))>1.e-10) THEN
-                         evaplsc = (-evaplsc)/(prfl(i,k+1)+psfl(i,k+1))
-                         ! evaplsc est donc positif, his_dh(i) est positif
-                         !--------------  
-                         d_tr_evapls(i,k,it)=0.5*evaplsc*(d_tr_lessi_nucl(i,k+1,it) &
-                              +d_tr_lessi_impa(i,k+1,it))
-                         !-------------   d_tr_evapls(i,k,it)=-0.5*evaplsc*(d_tr_lsc(i,k+1,it))
-                         beta=0.5*evaplsc
-                         if ((prfl(i,k)+psfl(i,k))<1.e-10) THEN
-                            beta=1.0*evaplsc
-                         endif
-                         dx=beta*his_dh(i)/zrho(i,k)/zdz(i,k)*pdtphys
-                         his_dh(i)=(1.-beta)*his_dh(i)   ! tracer from
-                         d_tr_evapls(i,k,it)=dx
-                      ENDIF
-                      d_tr_ls(i,k,it)=tr_seri(i,k,it)*(frac_impa(i,k)*frac_nucl(i,k)-1.) &
-                           +d_tr_evapls(i,k,it)
-
-                      !--------------
-                      d_tr_lessi_nucl(i,k,it) = d_tr_lessi_nucl(i,k,it) +    &
-                           ( 1 - frac_nucl(i,k) )*tr_seri(i,k,it)
-                      d_tr_lessi_impa(i,k,it) = d_tr_lessi_impa(i,k,it) +    &
-                           ( 1 - frac_impa(i,k) )*tr_seri(i,k,it)
-                      !
-                      ! Flux lessivage total 
-                      flestottr(i,k,it) = flestottr(i,k,it) -   &
-                           ( d_tr_lessi_nucl(i,k,it)   +        &
-                           d_tr_lessi_impa(i,k,it) ) *          &
-                           ( paprs(i,k)-paprs(i,k+1) ) /        &
-                           (RG * pdtphys)
-                      !! Mise a jour des traceurs due a l'impaction,nucleation 
-                      !                 tr_seri(i,k,it)=tr_seri(i,k,it)*frac_impa(i,k)*frac_nucl(i,k)
-                      !!  calcul de la tendance liee au lessivage stratiforme
-                      !                 d_tr_ls(i,k,it)=tr_seri(i,k,it)*&
-                      !                                (1.-1./(frac_impa(i,k)*frac_nucl(i,k)))
-                      !--------------
-                   ENDDO
-                ENDDO
-             ENDIF
-          ENDDO
-          ! *********   end modified old version
-
-       ELSE IF (iflag_lscav == 1) THEN ! frac_impa, frac_nucl
-          ! *********    old version
-
-          d_tr_lessi_nucl(:,:,:) = 0. 
-          d_tr_lessi_impa(:,:,:) = 0.
-          flestottr(:,:,:) = 0. 
-          !=========================
-          ! LESSIVAGE LARGE SCALE : 
-          !=========================
-
-          ! Tendance des aerosols nuclees et impactes 
-          ! -----------------------------------------
-          DO it = 1, nbtr
-             IF (aerosol(it)) THEN
-                DO k = 1, klev
-                   DO i = 1, klon
-                      d_tr_lessi_nucl(i,k,it) = d_tr_lessi_nucl(i,k,it) +    &
-                           ( 1 - frac_nucl(i,k) )*tr_seri(i,k,it)
-                      d_tr_lessi_impa(i,k,it) = d_tr_lessi_impa(i,k,it) +    &
-                           ( 1 - frac_impa(i,k) )*tr_seri(i,k,it)
-
-                      !
-                      ! Flux lessivage total 
-                      ! ------------------------------------------------------------
-                      flestottr(i,k,it) = flestottr(i,k,it) -   &
-                           ( d_tr_lessi_nucl(i,k,it)   +        &
-                           d_tr_lessi_impa(i,k,it) ) *          &
-                           ( paprs(i,k)-paprs(i,k+1) ) /        &
-                           (RG * pdtphys)
-                      !
-                      ! Mise a jour des traceurs due a l'impaction,nucleation 
-                      ! ----------------------------------------------------------------------
-                      tr_seri(i,k,it)=tr_seri(i,k,it)*frac_impa(i,k)*frac_nucl(i,k)
-                   ENDDO
-                ENDDO
-             ENDIF
-          ENDDO
-
-          ! *********   end old version
-       ENDIF  !  iflag_lscav  .EQ. 1, 2, 3 or 4
-       !
+              ENDDO
+            ENDDO
+          ENDIF
+        END IF
+
+      ELSE IF (iflag_lscav == 2) THEN ! frac_impa, frac_nucl
+        ! *********   modified  old version
+
+        d_tr_lessi_nucl(:, :, :) = 0.
+        d_tr_lessi_impa(:, :, :) = 0.
+        flestottr(:, :, :) = 0.
+        ! Tendance des aerosols nuclees et impactes
+        DO it = 1, nbtr
+          IF (aerosol(it)) THEN
+            his_dh(:) = 0.
+            DO k = 1, klev
+              DO i = 1, klon
+                !PhH
+                zrho(i, k) = pplay(i, k) / t_seri(i, k) / RD
+                zdz(i, k) = (paprs(i, k) - paprs(i, k + 1)) / zrho(i, k) / RG
+                !
+              ENDDO
+            ENDDO
+
+            DO k = klev - 1, 1, -1
+              DO i = 1, klon
+                !             d_tr_ls(i,k,it)=tr_seri(i,k,it)*(frac_impa(i,k)*frac_nucl(i,k)-1.)
+                dx = d_tr_ls(i, k, it)
+                his_dh(i) = his_dh(i) - dx * zrho(i, k) * zdz(i, k) / pdtphys !  kg/m2/s
+                evaplsc = prfl(i, k) - prfl(i, k + 1) + psfl(i, k) - psfl(i, k + 1)
+                ! Evaporation Partielle -> Liberation Partielle 0.5*evap
+                IF (evaplsc <0..and.abs(prfl(i, k + 1) + psfl(i, k + 1))>1.e-10) THEN
+                  evaplsc = (-evaplsc) / (prfl(i, k + 1) + psfl(i, k + 1))
+                  ! evaplsc est donc positif, his_dh(i) est positif
+                  !--------------
+                  d_tr_evapls(i, k, it) = 0.5 * evaplsc * (d_tr_lessi_nucl(i, k + 1, it) &
+                          + d_tr_lessi_impa(i, k + 1, it))
+                  !-------------   d_tr_evapls(i,k,it)=-0.5*evaplsc*(d_tr_lsc(i,k+1,it))
+                  beta = 0.5 * evaplsc
+                  if ((prfl(i, k) + psfl(i, k))<1.e-10) THEN
+                    beta = 1.0 * evaplsc
+                  endif
+                  dx = beta * his_dh(i) / zrho(i, k) / zdz(i, k) * pdtphys
+                  his_dh(i) = (1. - beta) * his_dh(i)   ! tracer from
+                  d_tr_evapls(i, k, it) = dx
+                ENDIF
+                d_tr_ls(i, k, it) = tr_seri(i, k, it) * (frac_impa(i, k) * frac_nucl(i, k) - 1.) &
+                        + d_tr_evapls(i, k, it)
+
+                !--------------
+                d_tr_lessi_nucl(i, k, it) = d_tr_lessi_nucl(i, k, it) + &
+                        (1 - frac_nucl(i, k)) * tr_seri(i, k, it)
+                d_tr_lessi_impa(i, k, it) = d_tr_lessi_impa(i, k, it) + &
+                        (1 - frac_impa(i, k)) * tr_seri(i, k, it)
+                !
+                ! Flux lessivage total
+                flestottr(i, k, it) = flestottr(i, k, it) - &
+                        (d_tr_lessi_nucl(i, k, it) + &
+                                d_tr_lessi_impa(i, k, it)) * &
+                                (paprs(i, k) - paprs(i, k + 1)) / &
+                                (RG * pdtphys)
+                !! Mise a jour des traceurs due a l'impaction,nucleation
+                !                 tr_seri(i,k,it)=tr_seri(i,k,it)*frac_impa(i,k)*frac_nucl(i,k)
+                !!  calcul de la tendance liee au lessivage stratiforme
+                !                 d_tr_ls(i,k,it)=tr_seri(i,k,it)*&
+                !                                (1.-1./(frac_impa(i,k)*frac_nucl(i,k)))
+                !--------------
+              ENDDO
+            ENDDO
+          ENDIF
+        ENDDO
+        ! *********   end modified old version
+
+      ELSE IF (iflag_lscav == 1) THEN ! frac_impa, frac_nucl
+        ! *********    old version
+
+        d_tr_lessi_nucl(:, :, :) = 0.
+        d_tr_lessi_impa(:, :, :) = 0.
+        flestottr(:, :, :) = 0.
+        !=========================
+        ! LESSIVAGE LARGE SCALE :
+        !=========================
+
+        ! Tendance des aerosols nuclees et impactes
+        ! -----------------------------------------
+        DO it = 1, nbtr
+          IF (aerosol(it)) THEN
+            DO k = 1, klev
+              DO i = 1, klon
+                d_tr_lessi_nucl(i, k, it) = d_tr_lessi_nucl(i, k, it) + &
+                        (1 - frac_nucl(i, k)) * tr_seri(i, k, it)
+                d_tr_lessi_impa(i, k, it) = d_tr_lessi_impa(i, k, it) + &
+                        (1 - frac_impa(i, k)) * tr_seri(i, k, it)
+
+                !
+                ! Flux lessivage total
+                ! ------------------------------------------------------------
+                flestottr(i, k, it) = flestottr(i, k, it) - &
+                        (d_tr_lessi_nucl(i, k, it) + &
+                                d_tr_lessi_impa(i, k, it)) * &
+                                (paprs(i, k) - paprs(i, k + 1)) / &
+                                (RG * pdtphys)
+                !
+                ! Mise a jour des traceurs due a l'impaction,nucleation
+                ! ----------------------------------------------------------------------
+                tr_seri(i, k, it) = tr_seri(i, k, it) * frac_impa(i, k) * frac_nucl(i, k)
+              ENDDO
+            ENDDO
+          ENDIF
+        ENDDO
+
+        ! *********   end old version
+      ENDIF  !  iflag_lscav  .EQ. 1, 2, 3 or 4
+      !
     ENDIF !  lessivage
 
 
     !    -- CHIMIE INCA  config_inca = aero or chem --
-    IF (ANY(type_trac == ['inca','inco'])) THEN  ! ModThL
-
-       CALL tracinca(&
-            nstep,    julien,   gmtime,         lafin,     &
-            pdtphys,  t_seri,   paprs,          pplay,     &
-            pmfu,     upwd,     ftsol,  pctsrf, pphis,     &
-            pphi,     albsol,   sh,    ch,     rh,        &
-            cldfra,   rneb,     diafra,         cldliq,    &
-            itop_con, ibas_con, pmflxr,         pmflxs,    &
-            prfl,     psfl,     aerosol_couple, flxmass_w, &
-            tau_aero, piz_aero, cg_aero,        ccm,       &
-            rfname,                                        &
-            tr_seri(:,:,1+nqCO2:nbtr),  source(:,1+nqCO2:nbtr))  ! ModThL  
+    IF (ANY(type_trac == ['inca', 'inco'])) THEN  ! ModThL
+
+      CALL tracinca(&
+              nstep, julien, gmtime, lafin, &
+              pdtphys, t_seri, paprs, pplay, &
+              pmfu, upwd, ftsol, pctsrf, pphis, &
+              pphi, albsol, sh, ch, rh, &
+              cldfra, rneb, diafra, cldliq, &
+              itop_con, ibas_con, pmflxr, pmflxs, &
+              prfl, psfl, aerosol_couple, flxmass_w, &
+              tau_aero, piz_aero, cg_aero, ccm, &
+              rfname, &
+              tr_seri(:, :, 1 + nqCO2:nbtr), source(:, 1 + nqCO2:nbtr))  ! ModThL
     ENDIF
 
Index: LMDZ6/branches/Amaury_dev/libf/phylmdiso/isotopes_mod.F90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/phylmdiso/isotopes_mod.F90	(revision 5095)
+++ LMDZ6/branches/Amaury_dev/libf/phylmdiso/isotopes_mod.F90	(revision 5098)
@@ -144,8 +144,8 @@
 !$OMP THREADPRIVATE(ok_prod_nucl_tritium)
    INTEGER, PARAMETER :: nessai = 486
-   INTEGER, DIMENSION(nessai), SAVE :: &
+   INTEGER, DIMENSION(nessai) :: &
                     day_nucl, month_nucl, year_nucl
 !$OMP THREADPRIVATE(day_nucl, month_nucl, year_nucl)
-   REAL,    DIMENSION(nessai), SAVE :: &
+   REAL,    DIMENSION(nessai) :: &
                     lat_nucl, lon_nucl, zmin_nucl, zmax_nucl, HTO_nucl
 !$OMP THREADPRIVATE(lat_nucl, lon_nucl, zmin_nucl, zmax_nucl, HTO_nucl)
Index: LMDZ6/branches/Amaury_dev/libf/phylmdiso/isotopes_routines_mod.F90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/phylmdiso/isotopes_routines_mod.F90	(revision 5095)
+++ LMDZ6/branches/Amaury_dev/libf/phylmdiso/isotopes_routines_mod.F90	(revision 5098)
@@ -17,4 +17,6 @@
 &       bidouille_anti_divergence, &
 &       iso_eau,iso_HDO,iso_O18
+USE lmdz_yomcst
+
 #ifdef ISOVERIF
 !USE isotopes_verif_mod, ONLY: errmax,errmaxrel
@@ -28,6 +30,4 @@
 #endif
 implicit none
-
-#include "YOMCST.h"       
 
 ! inputs
@@ -12962,5 +12962,6 @@
 &       bidouille_anti_divergence, ridicule,ridicule_snow, &
 &       tcorr,toce,alpha_liq_sol
-    USE indice_sol_mod    
+    USE indice_sol_mod
+    USE lmdz_yomcst
 #ifdef ISOVERIF
 !    USE isotopes_verif_mod, ONLY: errmax,errmaxrel,errmax_sol,deltalim_snow
@@ -12978,5 +12979,4 @@
 #include "YOETHF.h" 
 #include "FCTTRE.h"   
-#include "YOMCST.h"
 !#include "dimensions.h"
 !#include "paramet.h"
@@ -13534,4 +13534,5 @@
 &       rh_cste_surf_cond,Rdefault,T_cste_surf_cond,iso_O17,iso_O18, &
 &       ridicule_evap,tnat
+    USE lmdz_yomcst
 #ifdef ISOVERIF
 !    USE isotopes_verif_mod, ONLY: deltaDfaible, faible_evap,errmax,errmaxrel
@@ -13546,6 +13547,5 @@
 #include "YOETHF.h"         
 #include "FCTTRE.h"   
-#include "YOMCST.h"
-        
+
         ! inputs
         integer, intent(in) :: klon,knon ! dimensions
@@ -14447,4 +14447,5 @@
 &       ridicule_evap
 USE fonte_neige_mod, ONLY: gestion_neige_besoin_varglob_fonte_neige
+USE lmdz_yomcst
 #ifdef ISOVERIF
 !USE isotopes_verif_mod, ONLY: errmax,errmaxrel,errmax_sol,deltalim_snow, &
@@ -14460,8 +14461,5 @@
 
 #include "YOETHF.h" 
-#include "FCTTRE.h"   
-#include "YOMCST.h"
-!#include "dimensions.h"
-!#include "paramet.h"
+#include "FCTTRE.h"
         
         ! inputs
@@ -16634,10 +16632,9 @@
         USE geometry_mod, only: latitude_deg,longitude_deg, & ! en degré, remplace rlat et rlon
                    latitude,longitude ! en radian, remplace rlatd et rlond
+        USE lmdz_yomcst
 #ifdef ISOVERIF
         USE isotopes_verif_mod
 #endif
       implicit none
-
-#include "YOMCST.h"
 
 ! input
@@ -18232,4 +18229,5 @@
         USE dimphy, only: klon,klev
         use geometry_mod, only: latitude_deg,longitude_deg
+        USE lmdz_yomcst
 #ifdef ISOVERIF
         USE isotopes_verif_mod
@@ -18237,5 +18235,4 @@
       implicit none
 
-#include "YOMCST.h"
 #include "dimensions.h"
 ! pour avoir iim et jjm
@@ -18375,10 +18372,9 @@
         use geometry_mod, only: cell_area
         use dimphy, only: klon,klev
+        USE lmdz_yomcst
 #ifdef ISOVERIF
         USE isotopes_verif_mod
 #endif
       implicit none
-
-#include "YOMCST.h"
 
 !     Arguments
Index: LMDZ6/branches/Amaury_dev/libf/phylmdiso/lmdz_yomcst.f90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/phylmdiso/lmdz_yomcst.f90	(revision 5098)
+++ LMDZ6/branches/Amaury_dev/libf/phylmdiso/lmdz_yomcst.f90	(revision 5098)
@@ -0,0 +1,1 @@
+link ../phylmd/lmdz_yomcst.f90
